import { AriaLabelingProps, DOMProps, KeyboardDelegate, Node } from "@react-types/shared";
import { HTMLAttributes, RefObject, Key } from "react";
import { Layout } from "@react-stately/virtualizer";
import { TableState } from "@react-stately/table";
import { GridRowAria, GridRowProps } from "@react-aria/grid";
import { GridNode } from "@react-types/grid";
import { AriaCheckboxProps } from "@react-types/checkbox";
interface GridProps<T> extends DOMProps, AriaLabelingProps {
    ref: RefObject<HTMLElement>;
    isVirtualized?: boolean;
    keyboardDelegate?: KeyboardDelegate;
    layout?: Layout<Node<T>>;
}
interface GridAria {
    gridProps: HTMLAttributes<HTMLElement>;
}
export function useTable<T>(props: GridProps<T>, state: TableState<T>): GridAria;
interface ColumnHeaderProps {
    node: Node<unknown>;
    ref: RefObject<HTMLElement>;
    isVirtualized?: boolean;
    colspan?: number;
    isDisabled?: boolean;
}
interface ColumnHeaderAria {
    columnHeaderProps: HTMLAttributes<HTMLElement>;
}
export function useTableColumnHeader<T>(props: ColumnHeaderProps, state: TableState<T>): ColumnHeaderAria;
export function useTableRow<T>(props: GridRowProps<T>, state: TableState<T>): GridRowAria;
interface RowHeaderProps {
    node: GridNode<unknown>;
    ref: RefObject<HTMLElement>;
    isVirtualized?: boolean;
    isDisabled?: boolean;
}
interface RowHeaderAria {
    rowHeaderProps: HTMLAttributes<HTMLElement>;
}
export function useTableRowHeader<T>(props: RowHeaderProps, state: TableState<T>): RowHeaderAria;
interface SelectionCheckboxProps {
    key: Key;
    isDisabled?: boolean;
}
interface SelectionCheckboxAria {
    checkboxProps: AriaCheckboxProps;
}
export function useTableSelectionCheckbox<T>(props: SelectionCheckboxProps, state: TableState<T>): SelectionCheckboxAria;
export function useTableSelectAllCheckbox<T>(state: TableState<T>): SelectionCheckboxAria;
export { useGridCell as useTableCell } from '@react-aria/grid';
export { useGridRowGroup as useTableRowGroup } from '@react-aria/grid';

//# sourceMappingURL=types.d.ts.map
